SimulatedTlsSRPIdentityManager (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.crypto.tls

## Class SimulatedTlsSRPIdentityManager

- java.lang.Object
- - org.bouncycastle.crypto.tls.SimulatedTlsSRPIdentityManager

- All Implemented Interfaces:
    TlsSRPIdentityManager

      public class SimulatedTlsSRPIdentityManager
      extends java.lang.Object
      implements TlsSRPIdentityManager

  An implementation of `TlsSRPIdentityManager` that simulates the existence of "unknown" identities to obscure the fact that there is no verifier for them.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SRP6GroupParameters` | `group`
    `protected Mac` | `mac`
    `protected SRP6VerifierGenerator` | `verifierGenerator`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimulatedTlsSRPIdentityManager(SRP6GroupParameters group, SRP6VerifierGenerator verifierGenerator, Mac mac)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `TlsSRPLoginParameters` | `getLoginParameters(byte[] identity)` Lookup the `TlsSRPLoginParameters` corresponding to the specified identity.
    `static SimulatedTlsSRPIdentityManager` | `getRFC5054Default(SRP6GroupParameters group, byte[] seedKey)` Create a `SimulatedTlsSRPIdentityManager` that implements the algorithm from RFC 5054 2.5.1.3

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### group

          protected SRP6GroupParameters group

    - #### verifierGenerator

          protected SRP6VerifierGenerator verifierGenerator

    - #### mac

          protected Mac mac

  - ### Constructor Detail

    - #### SimulatedTlsSRPIdentityManager

          public SimulatedTlsSRPIdentityManager(SRP6GroupParameters group,
                                        SRP6VerifierGenerator verifierGenerator,
                                        Mac mac)

  - ### Method Detail

    - #### getRFC5054Default

          public static SimulatedTlsSRPIdentityManager getRFC5054Default(SRP6GroupParameters group,
                                                         byte[] seedKey)

      Create a `SimulatedTlsSRPIdentityManager` that implements the algorithm from RFC 5054 2.5.1.3
      Parameters:
        `group` - the `SRP6GroupParameters` defining the group that SRP is operating in
        `seedKey` - the secret "seed key" referred to in RFC 5054 2.5.1.3
      Returns:
        an instance of `SimulatedTlsSRPIdentityManager`

    - #### getLoginParameters

          public TlsSRPLoginParameters getLoginParameters(byte[] identity)

      Description copied from interface: `TlsSRPIdentityManager`
      Lookup the `TlsSRPLoginParameters` corresponding to the specified identity. NOTE: To avoid "identity probing", unknown identities SHOULD be handled as recommended in RFC 5054 2.5.1.3. `SimulatedTlsSRPIdentityManager` is provided for this purpose.
      Specified by:
        `getLoginParameters` in interface `TlsSRPIdentityManager`
      Parameters:
        `identity` - the SRP identity sent by the connecting client
      Returns:
        the `TlsSRPLoginParameters` for the specified identity, or else 'simulated' parameters if the identity is not recognized. A null value is also allowed, but not recommended.